#include <iostream>

using namespace std;

#include "donnees_tp2.hpp"

//**************
//* Exercice 1 *
//**************

// Question 1

void affiche_tableau(int* tab,int n){
  if(n==0){
    cout<<"[]"<<endl;
  }
  else{
    cout<<'[';
    cout<<tab[0];
    for(int i=1;i<n;++i){
      cout<<','<<tab[i];
    }
    cout<<']'<<endl;
  }
}

// Question 2

int min(int* tab,int n){
  if(n==0){
    cout<<"Tableau vide"<<endl;
    return 0;
  }
  int m=tab[0];
  for(int i=1;i<n;++i){
    if(tab[i]<m){
      m=tab[i];
    }
  }
  return m;
}

// Question 3

int max(int* tab,int n){
  if(n==0){
    cout<<"Tableau vide"<<endl;
    return 0;
  }
  int m=tab[0];
  for(int i=1;i<n;++i){
    if(tab[i]>m){
      m=tab[i];
    }
  }
  return m;
}

// Question 4

int somme(int* tab,int n){
  int s=0;
  for(int i=0;i<n;++i){
    s=s+tab[i];
  }
  return s;
}

//**************
//* Exercice 2 *
//**************

// Question 1

bool est_pair(int* tab,int n){
  for(int i=0;i<n;++i){
    if(tab[i]%2!=0){
      return false;
    }
  }
  return true;
}

// Question 2
bool est_trie(int* tab,int n){
  for(int i=0;i<n-1;++i){
    if(tab[i]>tab[i+1]){
      return false;
    }
  }
  return true;
}

// Question 3
int* copie(int* tab,int n){
  //Initialisation d'un tableau ntab de taille n
  int* ntab=new int[n];
  //Copie des éléments de tab dans ntab
  for(int i=0;i<n;++i){
    ntab[i]=tab[i];
  }
  return ntab;
}

//**************
//* Exercice 3 *
//**************

// Question 1

void tri_insertion(int* tab,int n){
  for(int i=1;i<n;++i){
    int pos=i;
    int elt=tab[i];
    while(pos>0 and tab[pos-1]>elt){
      tab[pos]=tab[pos-1];
      --pos;
    }
    tab[pos]=elt;
  }
}

// Question 2

int nle;
int nc;

bool est_inf(int a,int b){
  ++nc;
  return a<b;
}

int& lire(int* tab,int i){
  ++nle;
  return tab[i];
}

void ecrire(int* tab,int i,int v){
  ++nle;
  tab[i]=v;
}


void tri_insertion2(int* tab,int n){
  for(int i=1;i<n;++i){
    int pos=i;
    int elt=lire(tab,i);
    while(pos>0 and est_inf(elt,lire(tab,pos-1))){
      ecrire(tab,pos,lire(tab,pos-1));
      --pos;
    }
    ecrire(tab,pos,elt);
  }
}

//**************
//* Exercice 4 *
//**************

// Question 1

void tri_selection(int* tab,int n){
  for(int i=n-1;i>=1;--i){
    //Recherche du maximum dans tab[0..i]
    int pos=0;
    for(int j=1;j<=i;++j){
      if(tab[pos]<tab[j]){
	pos=j;
      }
    }
    //Le maximum de tab[0..i] est tab[pos]
    if(i!=pos){
      //On echange tab[i] et tab[pos]
      int temp=tab[i];
      tab[i]=tab[pos];
      tab[pos]=temp;
    }
  }
}

// Question 2

void tri_selection2(int* tab,int n){
  for(int i=n-1;i>=1;--i){
    //Recherche du maximum dans tab[0..i]
    int pos=0;
    for(int j=1;j<=i;++j){
      if(est_inf(lire(tab,pos),lire(tab,j))){
	pos=j;
      }
    }
    //Le maximum de tab[0..i] est tab[pos]
    if(i!=pos){
      //On echange tab[i] et tab[pos]
      int temp=lire(tab,i);
      ecrire(tab,i,lire(tab,pos));
      ecrire(tab,pos,temp);
    }
  }
}
//**************
//* Exercice 5 *
//**************

// Question 1

void fusion(int* tab,int deb,int milieu,int fin){
  int curg=deb;
  int curd=milieu+1;
  int* temp=new int[fin-deb+1];
  int pos=0;
  while(curg<=milieu and curd<=fin){
    if(tab[curg]<tab[curd]){
      //Si la valeur pointee par curg est inferieur a celle
      //pointe par curd on affecte temp[pos] a tab[curg] et
      //on deplace curg vers la droite
      temp[pos]=tab[curg];
      ++curg;
    }
    else{
      //De même en remplacant curg par curd
      temp[pos]=tab[curd];
      ++curd;
    }
    //On deplace pos
    ++pos;
  }
  //Ici l'un des tableaux de droite ou de gauche est epuisé.
  if(curg==milieu+1){
    //Il reste des éléments dans le tableau de droite
    for(;curd<=fin;++curd){
      temp[pos]=tab[curd];
      ++pos;
    }
  }
  else{
    //Il reste des éléments dans le tableau de gauche
    for(;curg<=milieu;++curg){
      temp[pos]=tab[curg];
      ++pos;
    }
  }
  //temp contient la fusion des tableaux triés
  //on met tab à jour
  for(int i=0;i<fin-deb+1;++i){
    tab[deb+i]=temp[i];
  }
}

void tri_fusion_rec(int* tab,int deb,int fin){
  if(deb<fin){
    int milieu=(deb+fin)/2;
    tri_fusion_rec(tab,deb,milieu);
    tri_fusion_rec(tab,milieu+1,fin);
    fusion(tab,deb,milieu,fin);
  }
}

void tri_fusion(int* tab,int n){
  tri_fusion_rec(tab,0,n-1);
}

// Question 2

void fusion2(int* tab,int deb,int milieu,int fin){
  int curg=deb;
  int curd=milieu+1;
  int* temp=new int[fin-deb+1];
  int pos=0;
  while(curg<=milieu and curd<=fin){
    if(est_inf(lire(tab,curg),lire(tab,curd))){
      //Si la valeur pointee par curg est inferieur a celle
      //pointe par curd on affecte temp[pos] a tab[curg] et
      //on deplace curg vers la droite
      ecrire(temp,pos,lire(tab,curg));
      ++curg;
    }
    else{
      //De même en remplacant curg par curd
      ecrire(temp,pos,lire(tab,curd));
      ++curd;
    }
    //On deplace pos
    ++pos;
  }
  //Ici l'un des tableaux de droite ou de gauche est epuisé.
  if(curg==milieu+1){
    //Il reste des éléments dans le tableau de droite
    for(;curd<=fin;++curd){
      ecrire(temp,pos,lire(tab,curd));
      ++pos;
    }
  }
  else{
    //Il reste des éléments dans le tableau de gauche
    for(;curg<=milieu;++curg){
      ecrire(temp,pos,lire(tab,curg));
      ++pos;
    }
  }
  //temp contient la fusion des tableaux triés
  //on met tab à jour
  for(int i=0;i<fin-deb+1;++i){
    ecrire(tab,deb+i,lire(temp,i));
  }
}

void tri_fusion_rec2(int* tab,int deb,int fin){
  if(deb<fin){
    int milieu=(deb+fin)/2;
    tri_fusion_rec2(tab,deb,milieu);
    tri_fusion_rec2(tab,milieu+1,fin);
    fusion2(tab,deb,milieu,fin);
  }
}

void tri_fusion2(int* tab,int n){
  tri_fusion_rec2(tab,0,n-1);
}
//**************
//* Exercice 7 *
//**************



int recherche(int* tab,int n,int e){
  int deb=0;
  int fin=n-1;
  while(deb<=fin){
    int m=(deb+fin)/2;
    if(tab[m]==e){//On a trouvé e dans tab
      return m;
    }
    else if(tab[m]>e){//e est a chercher dans tab[deb],...,tab[m-1]
      fin=m-1;
    }
    else{//e est a chercher dans tab[m+1],...,tab[fin]
      deb=m+1;
    }
  }
  return -1;
}


//********
//* Main *
//********

string affiche_bool(bool b){
  if(b==true) return "true";
  return "false";
}
int main(){
  cout<<"------------"<<endl;
  cout<<" Exercice 1 "<<endl;
  cout<<"------------"<<endl;
  cout<<endl<<"-> Question 1"<<endl;
  cout<<"- Affichage tab20 :"<<endl;
  affiche_tableau(tab20,20);
  cout<<endl<<"-> Question 2"<<endl;
  cout<<"- min de tab10 : "<<min(tab10,10)<<endl;
  cout<<"- min de tab20 : "<<min(tab20,20)<<endl;
  cout<<"- min de tab100 : "<<min(tab100,100)<<endl;
  cout<<endl<<"-> Question 3"<<endl;
  cout<<"- max de tab10 : "<<max(tab10,10)<<endl;
  cout<<"- max de tab20 : "<<max(tab20,20)<<endl;
  cout<<"- max de tab100 : "<<max(tab100,100)<<endl;
  cout<<endl<<"-> Question 4"<<endl;
  cout<<"- somme de tab10 : "<<somme(tab10,10)<<endl;
  cout<<"- somme de tab20 : "<<somme(tab20,20)<<endl;
  cout<<"- somme de tab100 : "<<somme(tab100,100)<<endl;
  cout<<endl;
  cout<<"------------"<<endl;
  cout<<" Exercice 2 "<<endl;
  cout<<"------------"<<endl;
  cout<<endl<<"-> Question 1"<<endl;
  cout<<"- est_pair tab10 : "<<affiche_bool(est_pair(tab10,10))<<endl;
  cout<<"- est_pair tab20 : "<<affiche_bool(est_pair(tab20,20))<<endl;
   cout<<endl<<"-> Question 2"<<endl;
  cout<<"- est_trie tab10 : "<<affiche_bool(est_trie(tab10,10))<<endl;
  cout<<"- est_trie tab20 : "<<affiche_bool(est_trie(tab20,20))<<endl;
  cout<<endl<<"-> Question 3"<<endl;
  cout<<"- Copie de tab10 : "<<endl;
  int* ntab10=copie(tab10,10);
  affiche_tableau(ntab10,10);
  cout<<"------------"<<endl;
  cout<<" Exercice 3 "<<endl;
  cout<<"------------"<<endl;
  cout<<endl<<"-> Question 1"<<endl;

  cout<<"- tri insertion tab10 : "<<endl;
  int* tab10_ins=copie(tab10,10);
  tri_insertion(tab10_ins,10);
  affiche_tableau(tab10_ins,10);
 
  cout<<"- tri insertion tab20 : "<<endl;
  int* tab20_ins=copie(tab20,20);
  tri_insertion(tab20_ins,20);
  affiche_tableau(tab20_ins,20);

  cout<<endl<<"-> Question 2"<<endl;
  nc=0;
  nle=0;
  cout<<endl<<"Insertion tab10"<<endl;
  int* tab10_ins2=copie(tab10,10);
  tri_insertion2(tab10_ins2,10);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  nc=0;
  nle=0;
  cout<<endl<<"Insertion tab20"<<endl;
  int* tab20_ins2=copie(tab20,20);
  tri_insertion2(tab20_ins2,20);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  nc=0;
  nle=0;
  cout<<endl<<"Insertion tab100"<<endl;
  int* tab100_ins2=copie(tab100,100);
  tri_insertion2(tab100_ins2,100);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  nc=0;
  nle=0;
  cout<<endl<<"Insertion tab1000"<<endl;
  int* tab1000_ins2=copie(tab1000,1000);
  tri_insertion2(tab1000_ins2,1000);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  cout<<"------------"<<endl;
  cout<<" Exercice 4 "<<endl;
  cout<<"------------"<<endl;
  cout<<endl<<"-> Question 1"<<endl;

  cout<<"- tri selection tab10 : "<<endl;
  int* tab10_sel=copie(tab10,10);
  tri_selection(tab10_sel,10);
  affiche_tableau(tab10_sel,10);
 
  cout<<"- tri selection tab20 : "<<endl;
  int* tab20_sel=copie(tab20,20);
  tri_selection(tab20_sel,20);
  affiche_tableau(tab20_sel,20);

    cout<<endl<<"-> Question 2"<<endl;
  nc=0;
  nle=0;
  cout<<endl<<"Selection tab10"<<endl;
  int* tab10_sel2=copie(tab10,10);
  tri_selection2(tab10_sel2,10);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  nc=0;
  nle=0;
  cout<<endl<<"Selection tab20"<<endl;
  int* tab20_sel2=copie(tab20,20);
  tri_selection2(tab20_sel2,20);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  nc=0;
  nle=0;
  cout<<endl<<"Selection tab100"<<endl;
  int* tab100_sel2=copie(tab100,100);
  tri_selection2(tab100_sel2,100);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  nc=0;
  nle=0;
  cout<<endl<<"Selection tab1000"<<endl;
  int* tab1000_sel2=copie(tab1000,1000);
  tri_selection2(tab1000_sel2,1000);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;
  
 

  cout<<"------------"<<endl;
  cout<<" Exercice 5 "<<endl;
  cout<<"------------"<<endl;
  cout<<endl<<"-> Question 1"<<endl;

  cout<<"- tri fusion tab10 : "<<endl;
  int* tab10_fus=copie(tab10,10);
  tri_fusion(tab10_fus,10);
  affiche_tableau(tab10_fus,10);

  cout<<"- tri fusion tab20 : "<<endl;
  int* tab20_fus=copie(tab20,20);
  tri_fusion(tab20_fus,20);
  affiche_tableau(tab20_fus,20);

   cout<<endl<<"-> Question 2"<<endl;
  nc=0;
  nle=0;
  cout<<endl<<"Fusion tab10"<<endl;
  int* tab10_fus2=copie(tab10,10);
  tri_fusion2(tab10_fus2,10);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  nc=0;
  nle=0;
  cout<<endl<<"Fusion tab20"<<endl;
  int* tab20_fus2=copie(tab20,20);
  tri_fusion2(tab20_fus2,20);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  nc=0;
  nle=0;
  cout<<endl<<"Fusion tab100"<<endl;
  int* tab100_fus2=copie(tab100,100);
  tri_fusion2(tab100_fus2,100);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  nc=0;
  nle=0;
  cout<<endl<<"Fusion tab1000"<<endl;
  int* tab1000_fus2=copie(tab1000,1000);
  tri_fusion2(tab1000_fus2,1000);
  cout<<"Comparaisons : "<<nc<<endl;
  cout<<"Lecture/Ecriture : "<<nle<<endl;

  cout<<"------------"<<endl;
  cout<<" Exercice 7 "<<endl;
  cout<<"------------"<<endl;

  tri_fusion(tab20,20);
  affiche_tableau(tab20,20);
  cout<<" 23 dans tab20 ? "<<recherche(tab20,20,23)<<endl;
  cout<<" 32 dans tab20 ? "<<recherche(tab20,20,32)<<endl;
  cout<<" 40 dans tab20 ? "<<recherche(tab20,20,40)<<endl;
}
